#!/usr/bin/perl
#################################################################################
#										#
# transfer tool for chipbasic8 verion 0.10					#
# copyright (c) 2006-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
#										#
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 2		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################
$dir=$ARGV[0];
$fname=$ARGV[1];
@lnum=("01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20");
system `stty 1200 cs8 -parenb -echo -crtscts -ixon < /dev/ttyS0`;

if ($dir eq "-r")
{
    print "waiting for data... ";
    open (PFIL, ">$fname");
    open (SER, "/dev/ttyS0");
    $data=<SER>;
    $data=~ s/\r//g;
    $pname=substr($data,500,12);
    print PFIL "--------++++++++++++--------\n";
    print PFIL "Program:".$pname."\n";
    print PFIL "---+++++++++++++++++++++++++\n";
    for($i=0;$i<20;$i++)
    {
	$line=substr($data,$i*25,25);
	print PFIL $lnum[$i]." ".$line."\n";	
    }    
    close(SER);
    close(PFIL);
    print " done\n";
}

if ($dir eq "-w")
{
    print "sending data... ";
    open (PFIL, "$fname");
    open (SER, ">/dev/ttyS0");
    $dummy=<PFIL>;
    $line=<PFIL>;
    $dummy=<PFIL>;    
    $pname=substr($line."               ",8,12);     
    $lines=0;
    while (<PFIL>)
    {    
	$data=$_;
	$ltext[$lines]=substr($_."                           ",3,25);
	$lines++;
    }
    $ctext="";
    for($i=0;$i<20;$i++)
    {
	if($i<$lines)
	{
	    $ctext.=$ltext[$i];	
	}
	else
	{
	    $ctext.="                         ";
	}
    }
    print SER $ctext.$pname."\n";
    close(SER);
    close(PFIL);
    print " done\n";
}
