;################################################################################
;#										#
;# chipbasic - single chip basic computer with ATMega 16			#
;# intro screen									#
;# copyright (c) 2006-8 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
intro_main:	libmio_setnormal		;set color
		libmio_clrscr			;clear screen
		libmio_thistext
		.db	22,2," (c)2006-8 Joerg Wolfram ",0
			
		ldi	YL,3
		ldi	YH,6
		ldi	ZL,54
		ldi	ZH,19
		libmio_fbox
	
		libmio_thistext
		.db	2,2,0,0
		ldi	tempreg3,13
intro_main_1:	libmio_thistext
		.db	255,0x10,0x20,0
		dec	tempreg3
		brne	intro_main_1

		libmio_thistext
		.db	10,2,0,0
		ldi	tempreg3,13
intro_main_2:	libmio_thistext
		.db	255,0x10,0x20,0
		dec	tempreg3
		brne	intro_main_2
		
		libmio_thisinvtext
.if ctype==8		
		.db	5,8,"AVR-ChipBasic8",0,0
.endif
.if ctype==16		
		.db	5,7,"AVR-ChipBasic8-16",0
.endif
.if ctype==88		
		.db	5,6,"AVR-ChipBasic8-88",0
.endif
		
		libmio_thistext
		.db	7,11,"V0.35",0

		ldi	tempreg3,100		;wait 2 seconds
intro_main_w:	libmio_sync
		dec	tempreg3
		brne	intro_main_w
		ret		
												
						