;################################################################################
;#										#
;# libmio - multi i/o for ATMega 16/32 	version 0.21				#
;# copyright (c) 2005/2006 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# * PAL/NTSC RGB videodisplay with up to 32x24 chars and 8 colors		#
;# * 1 channel sound can play notes and noise					#
;# * ps2-keyboard interface							#
;# * 1200 Bps bidirectional serial port						#
;# * pseudorandom generator							#
;# * 0,1s timer									#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;uncomment next line to enable the whole library if avr_libmake is not used
;.set	use_libmio_all	= 1

.def	libmio_cur_x	= r10
.def	libmio_cur_y	= r11

;--------------------------------------------------------------------------------
; user definitions
;--------------------------------------------------------------------------------
.equ	libmio_cols = 30
.equ	libmio_rows = 23

;.equ	libmio_vstart = 245
;.equ	libmio_vstop = 251
;.equ	libmio_hslen = 64
;.equ	libmio_counter = 1016
;.equ	libmio_maxlines = 7
;.equ	libmio_hstart = 112

.equ	libmio_vstart = 16
.equ	libmio_vstop = 21
.equ	libmio_hslen = 72
.equ	libmio_counter = 1023
.equ	libmio_maxlines = 56
.equ	libmio_hstart = 145
.equ	libmio_pixel_rows = 230
